#!/usr/bin/haserl
<? 
. /usr/lib/webif/webif.sh

#_subtitle=$( echo -n "<pre>"; cat /etc/issue.net; echo "</pre><br />" )

header "Status" "System" "System Status"

_phidget21version="$(phidget21version)"
_kversion="$( cat /proc/version )"
_distro="$( cat /etc/issue.net )"
_date="$(date)"
_mac="$(/sbin/ifconfig eth0 | grep HWaddr | awk '{print $5}')"
_board_name="$(cat /proc/cpuinfo | awk '/^Hardware/ {print $3}')"
_firmware_board=$( grep "board" /etc/phidgetsbc_version | awk '{print $2}' )
_firmware_date=$( grep "date" /etc/phidgetsbc_version )
_firmware_date=${_firmware_date#date }
_webifversion=$(dpkg -s phidgetsbcwebif | grep "^Version:" | awk '{print $2}')

cat <<EOF
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tr>
  <td colspan="2" class="listtopic">System information</td>
</tr>
<tr>
  <td width="25%" class="vncellt">Board Name</td>
  <td width="75%" class="listr">$_board_name</td>
</tr>
<tr>
  <td width="25%" class="vncellt">Board Revision</td>
  <td width="75%" class="listr">$_board_version</td>
</tr>
<tr>
  <td width="25%" class="vncellt">Webif Version</td>
  <td width="75%" class="listr">$_webifversion</td>
</tr>
<tr>
  <td width="25%" class="vncellt">Firmware Version</td>
  <td width="75%" class="listr">$_firmware_board - Version $_version - Built $_firmware_date</td>
</tr>
<tr>
  <td width="25%" class="vncellt">Kernel Version</td>
  <td width="75%" class="listr">$_kversion</td>
</tr>
<tr>
  <td width="25%" class="vncellt">Distribution</td>
  <td width="75%" class="listr">$_distro</td>
</tr>
<tr>
  <td width="25%" class="vncellt">Phidget Library</td>
  <td width="75%" class="listr">$_phidget21version</td>
</tr>
<tr>
  <td width="25%" class="vncellt">Current Date/Time</td>
  <td width="75%" class="listr">$_date</td>
</tr>
<tr>
  <td width="25%" class="vncellt">MAC Address</td>
  <td width="75%" class="listr">$_mac</td>
</tr>
<tr>
  <td colspan="2" class="list" height="12">&nbsp;</td>
</tr>
<tr>
  <td colspan="2">
	<table width="100%" border="0" cellspacing="0" cellpadding="0">
	  <tr>
		<td colspan="5" class="listtopic">Filesystem</td>
	  </tr>
	  <tr>
		<td width="20%" class="listhdrlr">Mountpoint</td>
		<td width="20%" class="listhdrr">Size</td>
		<td width="20%" class="listhdrr">Used</td>
		<td width="20%" class="listhdrr">Available</td>
		<td width="20%" class="listhdrr">Usage</td>
	  </tr>
EOF
					
df -h | awk '/(rootfs)|(media\/usb)/ {
		usepercent = substr($5, 1, length($5)-1);
		freepercent = 100 - int($5);
		print "              <tr>"
		print "                <td width=\"20%\" class=\"listlr\">" $6 "</td>"
		print "                <td width=\"20%\" class=\"listr\">" $2 "</td>"
		print "                <td width=\"20%\" class=\"listr\">" $3 "</td>"
		print "                <td width=\"20%\" class=\"listr\">" $4 "</td>"
		print "                <td width=\"20%\" class=\"listr\">"
		print "                  <img src=\"../images/bar_left.gif\" class=\"progbarl\" alt=\"\" /><img src=\"../images/bar_green.gif\" name=\"memusageu\" id=\"memusageu\" width=\"" usepercent "\" class=\"progbarcf\" alt=\"\" /><img src=\"../images/bar_gray.gif\" name=\"memusagef\" id=\"memusagef\" width=\"" freepercent "\" class=\"progbarc\" alt=\"\" /><img src=\"../images/bar_right.gif\" class=\"progbarr\" alt=\"\" /> " $5
		print "                </td>"
		print "              </tr>"
	}'

cat <<EOF
	</table>
  </td>
</tr>
<tr>
  <td colspan="2" class="list" height="12">&nbsp;</td>
</tr>
<tr>
  <td colspan="2" class="listtopic">Memory</td>
</tr>
EOF

free -o | awk '/Mem:/ {
		memtotal = $2;
		memtotalMiB = int($2) / 1024;
		memfreepercent = int($4) * 100 / int(memtotal);
		memtotalusedpercent = int($3) * 100 / int(memtotal);
		memchachebufferpercent = (int($6) + int($7)) * 100 / int(memtotal);
		memusedpercent = memtotalusedpercent - memchachebufferpercent;
	}
	END {
		print "        <tr>"
		print "          <td width=\"25%\" class=\"vncellt\">Memory usage</td>"
		print "          <td width=\"75%\" class=\"listr\">"
		print "            <img src=\"../images/bar_left.gif\" class=\"progbarl\" alt=\"\" /><img src=\"../images/bar_red.gif\" name=\"memusageu\" id=\"memusageu\" width=\"" int(memusedpercent) "\" class=\"progbarcf\" alt=\"\" /><img src=\"../images/bar_blue.gif\" name=\"memusageu\" id=\"memusageu\" width=\"" int(memchachebufferpercent) "\" class=\"progbarcf\" alt=\"\" /><img src=\"../images/bar_gray.gif\" name=\"memusagef\" id=\"memusagef\" width=\"" int(memfreepercent) "\" class=\"progbarc\" alt=\"\" /><img src=\"../images/bar_right.gif\" class=\"progbarr\" alt=\"\" />"
		printf("            &nbsp;%d&#37; of %.1fMiB\n", memtotalusedpercent, memtotalMiB);
		print "          </td>"
		print "        </tr>"
	}'

echo "</table>"

footer
?>
<!--
##WEBIF:name:Status:100:System
-->
